#ifndef GIT_COMMAND_H_INCLUDED
#define GIT_COMMAND_H_INCLUDED

#include <QStringList>
#include <QScopedPointer>

class QProcess;
class GitCommand {
    static bool initEnv;
    QString m_workingDirectory;

    bool exec(QStringList const &options, int start_timeout = 100000,
              int finish_timeout = 100000);
public:
    GitCommand();


    bool status(int start_timeout = 100000, int finish_timeout = 100000);
    bool check(int start_timeout = 100000, int finish_timeout = 100000);
    bool checkout(int start_timeout = 100000, int finish_timeout = 100000);
    bool clone(int start_timeout = 100000, int finish_timeout = 100000);
    bool pull(int start_timeout = 100000, int finish_timeout = 100000);
};

#endif // GIT_COMMAND_H_INCLUDED
