#ifndef COMMAND_H_INCLUDED
#define COMMAND_H_INCLUDED

#include <QObject>
#include <QCoreApplication>
#include <QString>
#include <QStringList>
#include <QProcess>
#include <QScopedPointer>

class Command : public QObject {
    Q_OBJECT

    QString m_command;
    QString m_commandResult;

    int m_waitForStartTimeout;
    int m_waitForFinishTimeout;
    int m_exitCode;
    QString m_workingDirectory;

    QScopedPointer<QProcess> m_p;

    QStringList m_args;

public:
    Command(QString command,
            QStringList args,
            QString workingDirectory,
            int start_timeout = 100000,
            int finish_timeout = 100000);

    QString getCommandResult(bool reset = false);
    QString command() const { return m_command; }

    bool exec();
    int exitCode() const { return m_exitCode; }

private slots:
    virtual void readyReadStandardOutput();
    virtual void readyReadStandardError();
};

#endif // COMMAND_H_INCLUDED
