#ifndef UTILS_INTERNAL_H_INCLUDED
#define UTILS_INTERNAL_H_INCLUDED

#include <QString>

namespace internal {

    static constexpr const char *UPDATE_NOT_NECESSARY{"not necessary"};
    static constexpr const char *UPDATE_NOT_REQUESTED{"not requested"};
    static constexpr const char *UPDATE_REQUESTED{"requested"};
    static constexpr const char *NO_CUSTOMER_REPOSITORY{"no customer repository"};
    static constexpr const char *ISMAS_CONNECTED{"connected"};
    static constexpr const char *ISMAS_DISCONNECTED{"disconnected"};
    static constexpr const char *ISMAS_DISCONNECTING{"disconnecting"};
    static constexpr const char *ISMAS_NOT_CONNECTED{"not connected"};
    static constexpr const char *ISMAS_CONNECTION_IN_PROGRESS{"connecting"};
    static constexpr const char *GIT_CUSTOMER_REPO_CHECKOUT_ERROR{"checkout error"};
    static constexpr const char *GIT_CUSTOMER_REPO_PULL_ERROR{"pull error"};
    static constexpr const char *GIT_CUSTOMER_REPO_UP_TO_DATE{"up to date"};
    static constexpr const char *EXEC_OPKG_COMMANDS_SUCCESS{"success"};
    static constexpr const char *UPDATE_DC_JSON_FILES_SUCCESS{"success"};
    static constexpr const char *SYNC_CUSTOMER_REPO_FILES_SUCCESS{"success"};
    static constexpr const char *UPDATE_DC_FIRMARE_SUCCESS{"success"};

    int read1stLineOfFile(QString fileName);
    QString customerRepoRoot();
    QString customerRepoDir();
    QString customerRepoDirName();
    QString repositoryUrl();
    QString branchName();
    bool customerRepoExists();
}

#endif // UTILS_INTERNAL_H_INCLUDED
